import ../../types
import options
export types
import json

type
  CommonData* = object
    lines*:       JsonNode
    remarks*:     seq[Remark]
    operators*:   seq[Operator]
    points*:      seq[Point]
    polylines*:   seq[Polyline]
    dateStr*:     string
    timestamp*:   int64

  HafasStopParams* = object
    aTimeS*:      Option[string]
    aPlatfS*:     Option[string]
    aTZOffset*:   Option[int]
    aCncl*:       Option[bool]
    aTimeR*:      Option[string]
    aPlatfR*:     Option[string]
    dTimeS*:      Option[string]
    dPlatfS*:     Option[string]
    dTZOffset*:   Option[int]
    dCncl*:       Option[bool]
    dTimeR*:      Option[string]
    dPlatfR*:     Option[string]
    locX*:        Option[int]

  HafasProdCtx* = object
    name*:     string
    num*:      string
    catOut*:   string
    catOutL*:  string
    lineId*:   Option[string]

  HafasProd* = object
    name*:     string
    cls*:      int
    icoX*:     int
    nameS*:    Option[string]
    addName*:  Option[string]
    opX*:      Option[int]
    prodCtx*:  HafasProdCtx

  HafasLocRef* = object
    ppIdx*: int
    locX*: int

  HafasPolyline* = object
    crdEncYX*: string
    ppLocRefL*: Option[seq[HafasLocRef]]
